/*
 * @(#)Point3D.java    Pzt 10 May 2010 14:32:03 EEST
 *
 * Point 3d for 3d world
 */
/*
*** This program wrote under GNU/General Public License ***

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
*/
package net.dilmerkezi.point;

/**
 * @author Murat iNAN, dilmerkezi.net/eng.html
 */
public interface Point3D
{

    /**
     * @param p Other point for subtracting than main point
     * @return Subtracted 3D point
     */
    public Point3D subtract (Point3D p);

    /** @return Normalized 3D point*/
    public Point3D normalize ();
    
    /**
     * @param 3D point for uisng in reflection 
     * @return Reflected 3D point
     */
    public Point3D reflect (Point3D p);
    
    /**
     * @param p 3D Point for using in transformation
     * @return Transformed 3D point
     */
    public Point3D transform (Point3D p);
    
    /**
     * @param p 3D Point for using in crossing
     * @return Crossed 3D point
     */
    public Point3D cross (Point3D p);
    
    /**
     * @param d Multiplation number
     * @return Multipled 3D point
     */
    public Point3D mult (double d);
    
    /**
     * @param p 3D point for using in dot
     * @param Dot value
     */
    public double dot (Point3D p);
    
    /** @return X coordinate*/
    public double getX ();
    
    /** @return Y coordinate*/
    public double getY ();
    
    /** @return Z coordinate*/
    public double getZ ();
    
    /** @return Length of Point3D*/
    public double length ();
    
}
/****************/
